# include "listaLib.h"

//Funzioni  ausiliaria
ListaDiElementi inTesta(ListaDiElementi L, int v){
ListaDiElementi aux=malloc(sizeof(ElementoLista));
aux->info=v;
aux->next=L;
return aux;
}

void InserisciTestalista (ListaDiElementi *L, int v){
    ListaDiElementi aux=malloc(sizeof(ElementoLista));
    aux->info=v;
    aux->next=*L;
   *L=aux;
}
/*Lettura ricorsiva di una lista usa inTesta modifica il parametro*/
void readListIntRic (ListaDiElementi *L, int K ) {
if (K>0) 
        { int x;
          printf("Digita un intero elemento della lista\n");
          scanf("%d",&x);
          *L=inTesta(*L,x);
          readListIntRic(L,K-1);
        }
        }

/*Es 10.1 Stampa ricorsiva di una lista di interi */
void writeListIntRic (ListaDiElementi L ){
if (L!=NULL) if (L->next!=NULL )
                    {printf("%d, ",L->info);
                     writeListIntRic(L->next);
                    }
                    else printf("%d",L->info);
}
/*Es 10.2 Stampa iterativa di una lista di interi */
void writeListIntIt (ListaDiElementi L ){
printf("La lista contiene i seguenti elementi: \n (");
while(L!=NULL){
    printf("%d", L->info);
    if (L->next!=NULL) printf(", ");
    L=L->next;} //fine while
printf(")\n");
}

/*Es 10.3Calcolo del minimo in una lista di interi  versione ricorsiva
si applica solo a liste non vuote su una lista vuota genera un errore a run time*/
int minListaIntRic (ListaDiElementi L){
 if (L->next==NULL) return L->info;
 else {int x=minListaIntRic(L->next);
        if (L->info<x) return L->info;
        else return x;
}}

/*Es 10.4 Calcolo del minimo in una lista di interi versione iterativa
si applica solo a liste non vuote su una lista vuota genera un errore a run time*/
int minListaIntIt (ListaDiElementi L){
 int min=L->info;
 while (L->next!=NULL)
    { L=L->next;
    if (L->info<min) min= L->info;
    }
 return min;
}

/*Es 10.5 Ricerca un elemento in una lista NON ordinata versione iterativa */
Boolean ricercaListaIntRic (ListaDiElementi L,int x, int *p) {
if(L==NULL)  return false;
else if (L->info==x) {(*p)++;return true;}
else  {(*p)++; return ricercaListaIntRic(L->next, x,p);}
}

/*Es 10.6 Ricerca un elemento in una lista NON ordinata versione iterativa */
Boolean ricercaListaIntIt (ListaDiElementi L,int x, int *p) {
*p=0;
while(L!=NULL)
   if(L->info==x) {(*p)++;return true;}
  else{(*p)++; L=L->next;}
  return false;
}

/*Es 10.7 Lettura iterativa di una lista usa inTesta modifica il parametro*/
void readListIntIt (ListaDiElementi *L, int K) {
int i;
for (i=0;i<K;i++)
 {  int x;
    printf("Digita un intero elemento della lista\n");
    scanf("%d",&x);
    *L=inTesta(*L,x);
}}
/*Es 10.8 Versione readListInt */
ListaDiElementi readListIntRicFun (ListaDiElementi L,int K ) {
if (K>0) 
        { int x;
          printf("Digita un intero elemento della lista\n");
          scanf("%d",&x);
          return readListIntRicFun(inTesta(L,x),K-1);
        }}

/*Es 10.9 Versione readListIntRic che usa inserisci testaLista */
void readListIntRicTesta (ListaDiElementi *L, int K ) {
if (K>0) 
        { int x;
          printf("Digita un intero elemento della lista\n");
          scanf("%d",&x);
          InserisciTestalista(L,x);
          readListIntRic(L,K-1);
        }
        }


/*Es. 10.10 Copia di una lista L, la funzione restituisce la copia come risultato*/
ListaDiElementi copiaRic(ListaDiElementi L){
 if (L==NULL)return NULL;
 else {ListaDiElementi L1=malloc(sizeof(ElementoLista));
        L1->info=L->info;
        L1->next=copiaRic(L->next);
        return L1;
 }
}

/*Es.10.11 Copia di una lista L, la funzione restituisce la copia come risultato*/
ListaDiElementi copiaIt(ListaDiElementi L){
    ListaDiElementi aux=NULL;//ultimo elemento creato
    ListaDiElementi L1=NULL;//testa nuova lista
    while (L!=NULL)
      {
       if (L1==NULL)  //La nuova lista e` vuota
       {aux=malloc(sizeof(ElementoLista));
        L1=aux;
       }
       else{aux->next=malloc(sizeof(ElementoLista));
            aux=aux->next;}
      aux->info=L->info;
      aux->next=NULL;
      L=L->next;}
    return L1;
}
